<!DOCTYPE html>
<html lang="en">

<head>
  <title>task38.30</title>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.3.0/css/all.min.css">
  <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js"></script>
  <!-- Import style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.13.3/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.13.3/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.13.3/js/dataTables.bootstrap4.min.js"></script>
  <style>
    ::placeholder {
      color: red;
      opacity: 1;
      /* Firefox */
    }
  </style>
</head>

<body>
  <div class="container">
    <h1 class="text-center mb-5">F200 - LỊCH SỬ QUAY DICE</h1>
  </div>
  <div class="container jumbotron">
    <div class="row">
      <h2>Thông tin người chơi</h2>
    </div>
    <div class="row">
      <div class="col-sm-2">
        <label for="inp-user-name">User name</label>
      </div>
      <div class="col-sm-2">
        <input id="inp-user-name" class="form-control bg-primary text-light" type="text" placeholder="User name">
      </div>

      <div class="col-sm-2">
        <label for="inp-first-name">First name</label>
      </div>
      <div class="col-sm-2">
        <input id="inp-first-name" class="form-control bg-primary text-light" type="text" placeholder="First name">
      </div>

      <div class="col-sm-2">
        <label for="inp-last-name">Last name</label>
      </div>
      <div class="col-sm-2">
        <input id="inp-last-name" class="form-control bg-primary text-light" type="text" placeholder="Last name">
      </div>
    </div>
  </div>
  <!-- bảng table -->
  <div class="container jumbotron">
    <table id="dice-table" class="table table-striped table-hover table-bordered">
      <thead class="table-primary">
        <tr>
          <th>Lần chơi</th>
          <th>Kết quả</th>
        </tr>
      </thead>
      <tbody class="table-info">

      </tbody>
    </table>
  </div>

</body>
<script>
  "use strict"

  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  var gStt  = 0;

  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  $(document).ready(function () {
    onPageLoading();
  });
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  function onPageLoading() {
    "use strict"
    console.log("đã load xong thẻ body ");
    loadDataTable();// khời tạo data table 
    // b1 thu thập dữ liệu từ queryString
    var vUserName = queryString();
    console.log("đối   tượng truyền qua từ queryString", vUserName);
    // b2 . validate data  bỏ qua 
    // b3 đổ dữ liệu vào các ô input
    loadDataQyeryStringInput(vUserName);
    // b4 kiểm tra user và  gọi sever 
    if (vUserName.username != "") {
      getApiHistoryDice(vUserName.username, function (paramRes) {
        // b5 load data trả về lên table 
        console.log(paramRes);
        var vArrObject = chageArrToObject(paramRes.dices) // chuyển arr thành arr object ;
        console.log("arrObject", vArrObject);
        getInsertRowTable(vArrObject);   // hiển thị các hàng ra table .. bằng arr object
      });
    }
    else {
      console.log("user không hợp lệ");
    }

  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  // xử lý onpage loading
  function loadDataTable() {
    // 1 khai báo mảng chưa giá trị các cột 
    const ARRAY_NAME_COL = ["stt", "dice"];
    // 2 định nghĩa số thứ tự cho các cột
    const COL_STT = 0;
    const COL_LOAI = 1;
    // 3 cấu hình data table 
    $("#dice-table").DataTable({
      columns: [
        { data: ARRAY_NAME_COL[COL_STT] },
        { data: ARRAY_NAME_COL[COL_LOAI] },
      ],
      columnDefs: [
        {
          targets: 0,   // cột STT
          defaultContent: "1",
          render: function () {
            gStt++;
            return gStt;
          },
          className: "text-center text-primary",
        },
      ]
    })
  }

  // thêm dữ liệu lên bảng 
  function getInsertRowTable(paramRes) {
    var vTable = $("#dice-table").DataTable();
    vTable.clear();// xóa trắng tbody trước khi load dữ liệu  
    vTable.rows.add(paramRes);  // thêm data vào đây 
    vTable.draw();      // render dữ liệu ra bảng 
    gStt = 1;  // làm mới lại biến toàn cục,
    // $('#example').tooltip(options)
  }
  // thu thập và trả về user name qua queryString
  function queryString() {
    var vObjectData = {
      username: "",
      firstname: "",
      lastname: "",
    }
    var vUrl = window.location.href;
    var vNewUrl = new URL(vUrl);
    vObjectData.firstname = vNewUrl.searchParams.get("firstname");
    vObjectData.username = vNewUrl.searchParams.get("username");
    vObjectData.lastname = vNewUrl.searchParams.get("lastname");

    return vObjectData;
  }
  // b3 đổ dữ liệu lên ô input 
  function loadDataQyeryStringInput(paramObject) {
    $("#inp-user-name").val(paramObject.username);
    $("#inp-first-name").val(paramObject.firstname);
    $("#inp-last-name").val(paramObject.lastname);
  }
  // gọi server để lấy lịch sử tung xúc xắc qua user name
  function getApiHistoryDice(paramUserName, paramFunction) {
    $.ajax({
      url: "http://203.171.20.210:8080/devcamp-lucky-dice" + "/dice-history?username=" + paramUserName,
      type: "GET",
      dataType: "json",
      success: paramFunction,
      error: function () {
        console.log("gọi server dice history không thành công");
      }
    });
  }
  // chuyển arr thành arr object 
  function chageArrToObject(paramArr){
    var vNewArrObject = [];
    for(var i = 0; i < paramArr.length; i++){
      var vObject = {
        stt: i,
        dice: paramArr[i]}; // tạo đối tượng cho mỗi phần tử
      vNewArrObject.push(vObject); // thêm phần tử vào mảng
    }
    return vNewArrObject;
  }

</script>

</html>